"""The main code with all the modules loading and running them. Will have to adapt to the new code 927
The final step would be to add the sampling algorithm here...."""


from data_loader import load_data
from preprocessor import preprocess_data
from arima_model import plot_time_series
from lstm_model import create_dataset, plot_training_history, plot_forecast
from utils import load_config

def main():
    config = load_config('config.yaml')

    # Load and preprocess data
    data = load_data(config['data_path'])
    scaled_data, scaler = preprocess_data(data)

    # ARIMA Model
    arima_model = train_arima_model(scaled_data, **config['arima_params'])
    plot_arima_results(scaled_data, arima_model, 10, config['output_path'])

    # LSTM Model
    lstm_model = create_lstm_model((scaled_data.shape[1], 1), config['lstm_params']['neurons'])
    lstm_model = train_lstm_model(lstm_model, scaled_data, scaled_data, config['lstm_params']['epochs'], config['lstm_params']['batch_size'])
    plot_lstm_results(scaled_data, lstm_model, scaler, 10, config['output_path'])

if __name__ == "__main__":
    main()
